<?xml version='1.0' encoding='UTF-8'?>
<root>
 <tabbed_widget parent="main_window" name="Main Window">
  <Tab containers="1" tab_name="tab1">
   <Container>
    <DockSplitter orientation="-" count="2" sizes="0.500331;0.499669">
     <DockSplitter orientation="|" count="3" sizes="0.33438;0.33124;0.33438">
      <DockArea name="X position (m)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="0.000169" left="89.728000" bottom="-0.000175" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/x"/>
        <curve color="#ff7f0e" name="panda_2/x"/>
       </plot>
      </DockArea>
      <DockArea name="Y position (m)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="0.105009" left="89.728000" bottom="-0.105008" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/y"/>
        <curve color="#ff7f0e" name="panda_2/y"/>
       </plot>
      </DockArea>
      <DockArea name="Z position (m)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="0.502998" left="89.728000" bottom="0.502985" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/z"/>
        <curve color="#ff7f0e" name="panda_2/z"/>
       </plot>
      </DockArea>
     </DockSplitter>
     <DockSplitter orientation="|" count="3" sizes="0.33438;0.33124;0.33438">
      <DockArea name="X force (N)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="3.511263" left="89.728000" bottom="-2.849668" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/fx"/>
        <curve color="#ff7f0e" name="panda_2/fx"/>
       </plot>
      </DockArea>
      <DockArea name="Y force (N)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="2.021886" left="89.728000" bottom="-2.403825" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/fy"/>
        <curve color="#ff7f0e" name="panda_2/fy"/>
       </plot>
      </DockArea>
      <DockArea name="Z force (N)">
       <plot flip_x="false" flip_y="false" style="Lines" mode="TimeSeries">
        <range top="2.053865" left="89.728000" bottom="-2.198681" right="94.729000"/>
        <limitY/>
        <curve color="#1f77b4" name="panda_1/fz"/>
        <curve color="#ff7f0e" name="panda_2/fz"/>
       </plot>
      </DockArea>
     </DockSplitter>
    </DockSplitter>
   </Container>
  </Tab>
  <currentTabIndex index="0"/>
 </tabbed_widget>
 <use_relative_time_offset enabled="1"/>
 <!-- - - - - - - - - - - - - - - -->
 <!-- - - - - - - - - - - - - - - -->
 <Plugins>
  <plugin ID="DataLoad CSV">
   <default time_axis="" delimiter="0"/>
  </plugin>
  <plugin ID="DataLoad MCAP"/>
  <plugin ID="DataLoad ROS bags">
   <use_header_stamp value="false"/>
   <discard_large_arrays value="true"/>
   <max_array_size value="100"/>
   <boolean_strings_to_number value="true"/>
   <remove_suffix_from_strings value="true"/>
  </plugin>
  <plugin ID="DataLoad ULog"/>
  <plugin ID="ROS Topic Subscriber">
   <use_header_stamp value="false"/>
   <discard_large_arrays value="true"/>
   <max_array_size value="100"/>
   <boolean_strings_to_number value="true"/>
   <remove_suffix_from_strings value="true"/>
  </plugin>
  <plugin ID="UDP Server"/>
  <plugin ID="WebSocket Server"/>
  <plugin ID="ZMQ Subscriber"/>
  <plugin ID="Fast Fourier Transform"/>
  <plugin ID="Quaternion to RPY"/>
  <plugin ID="Reactive Script Editor">
   <library code="--[[ Helper function to create a series from arrays&#xa;&#xa; new_series: a series previously created with ScatterXY.new(name)&#xa; prefix:     prefix of the timeseries, before the index of the array&#xa; suffix_X:   suffix to complete the name of the series containing the X value. If [nil], use the index of the array.&#xa; suffix_Y:   suffix to complete the name of the series containing the Y value&#xa; timestamp:   usually the tracker_time variable&#xa;              &#xa; Example:&#xa; &#xa; Assuming we have multiple series in the form:&#xa; &#xa;   /trajectory/node.{X}/position/x&#xa;   /trajectory/node.{X}/position/y&#xa;   &#xa; where {N} is the index of the array (integer). We can create a reactive series from the array with:&#xa; &#xa;   new_series = ScatterXY.new(&quot;my_trajectory&quot;) &#xa;   CreateSeriesFromArray( new_series, &quot;/trajectory/node&quot;, &quot;position/x&quot;, &quot;position/y&quot;, tracker_time );&#xa;--]]&#xa;&#xa;function CreateSeriesFromArray( new_series, prefix, suffix_X, suffix_Y, timestamp )&#xa;  &#xa;  --- clear previous values&#xa;  new_series:clear()&#xa;  &#xa;  --- Append points to new_series&#xa;  index = 0&#xa;  while(true) do&#xa;&#xa;    x = index;&#xa;    -- if not nil, get the X coordinate from a series&#xa;    if suffix_X ~= nil then &#xa;      series_x = TimeseriesView.find( string.format( &quot;%s.%d/%s&quot;, prefix, index, suffix_X) )&#xa;      if series_x == nil then break end&#xa;      x = series_x:atTime(timestamp)&#x9; &#xa;    end&#xa;    &#xa;    series_y = TimeseriesView.find( string.format( &quot;%s.%d/%s&quot;, prefix, index, suffix_Y) )&#xa;    if series_y == nil then break end &#xa;    y = series_y:atTime(timestamp)&#xa;    &#xa;    new_series:push_back(x,y)&#xa;    index = index+1&#xa;  end&#xa;end&#xa;&#xa;--[[ Similar to the built-in function GetSeriesNames(), but select only the names with a give prefix. --]]&#xa;&#xa;function GetSeriesNamesByPrefix(prefix)&#xa;  -- GetSeriesNames(9 is a built-in function&#xa;  all_names = GetSeriesNames()&#xa;  filtered_names = {}&#xa;  for i, name in ipairs(all_names)  do&#xa;    -- check the prefix&#xa;    if name:find(prefix, 1, #prefix) then&#xa;      table.insert(filtered_names, name);&#xa;    end&#xa;  end&#xa;  return filtered_names&#xa;end&#xa;&#xa;--[[ Modify an existing series, applying offsets to all their X and Y values&#xa;&#xa; series: an existing timeseries, obtained with TimeseriesView.find(name)&#xa; delta_x: offset to apply to each x value&#xa; delta_y: offset to apply to each y value &#xa;  &#xa;--]]&#xa;&#xa;function ApplyOffsetInPlace(series, delta_x, delta_y)&#xa;  -- use C++ indeces, not Lua indeces&#xa;  for index=0, series:size()-1 do&#xa;    x,y = series:at(index)&#xa;    series:set(index, x + delta_x, y + delta_y)&#xa;  end&#xa;end&#xa;"/>
   <scripts/>
  </plugin>
  <plugin ID="CSV Exporter"/>
  <plugin ID="ROS /rosout Visualization"/>
  <plugin ID="ROS Topic Re-Publisher"/>
 </Plugins>
 <!-- - - - - - - - - - - - - - - -->
 <previouslyLoaded_Datafiles/>
 <previouslyLoaded_Streamer name="ROS Topic Subscriber"/>
 <!-- - - - - - - - - - - - - - - -->
 <customMathEquations>
  <snippet name="panda_2/fx">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/franka_state_controller/F_ext/wrench/force/x</linked_source>
  </snippet>
  <snippet name="panda_2/z">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/torque_control/current_cartesian_pose/pose/position/z</linked_source>
  </snippet>
  <snippet name="panda_2/x">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/torque_control/current_cartesian_pose/pose/position/x</linked_source>
  </snippet>
  <snippet name="panda_2/fz">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/franka_state_controller/F_ext/wrench/force/z</linked_source>
  </snippet>
  <snippet name="panda_1/fz">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/franka_state_controller/F_ext/wrench/force/z</linked_source>
  </snippet>
  <snippet name="panda_2/y">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/torque_control/current_cartesian_pose/pose/position/y</linked_source>
  </snippet>
  <snippet name="panda_1/fy">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/franka_state_controller/F_ext/wrench/force/y</linked_source>
  </snippet>
  <snippet name="panda_1/fx">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/franka_state_controller/F_ext/wrench/force/x</linked_source>
  </snippet>
  <snippet name="panda_1/z">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/torque_control/current_cartesian_pose/pose/position/z</linked_source>
  </snippet>
  <snippet name="panda_2/fy">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_2/franka_state_controller/F_ext/wrench/force/y</linked_source>
  </snippet>
  <snippet name="panda_1/y">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/torque_control/current_cartesian_pose/pose/position/y</linked_source>
  </snippet>
  <snippet name="panda_1/x">
   <global></global>
   <function>return value</function>
   <linked_source>/panda_1/torque_control/current_cartesian_pose/pose/position/x</linked_source>
  </snippet>
 </customMathEquations>
 <snippets/>
 <!-- - - - - - - - - - - - - - - -->
</root>

